From 09bd1007ce147a2af8b076302f534cc9ad36221d Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 2/32] Issues: Fetch VCS details from hub config


---

diff --git a/hubs/models/hubconfig.py b/hubs/models/hubconfig.py
index d103681..a4a8db6 100644
--- a/hubs/models/hubconfig.py
+++ b/hubs/models/hubconfig.py
@@ -105,8 +105,9 @@ class HubConfigProxy(MutableMapping):
         "visibility", "chat_domain", "chat_channel", "mailing_list",
         "calendar", "meetings_text", "rules_url", "timezone_offset",
         "chat_nickname", "email", "creation_date", "country",
+        "pagure_username", "github_username", "bugzilla_email",
         "mailing_list_url",
-    ) + tuple(p["name"] for p in DEV_PLATFORMS)
+           ) + tuple(p["name"] for p in DEV_PLATFORMS)
     CONVERTERS = {
         "archived": BooleanConverter(),
         "left_width": Converter(int),
@@ -125,6 +126,8 @@ class HubConfigProxy(MutableMapping):
     }
     LISTS = ("pagure", "github")
     VALIDATORS = {
+        "github_username": validators.GithubOrganization,
+        "pagure_username": validators.PagureUser,
         "github": validators.GithubOrgAndRepo,
         "pagure": validators.PagureRepo,
         "chat_domain": validators.ChatDomain,
diff --git a/hubs/static/client/app/components/HubConfig/HubConfigPanelDetails.js b/hubs/static/client/app/components/HubConfig/HubConfigPanelDetails.js
new file mode 100644
index 0000000..ec639b5
--- /dev/null
+++ b/hubs/static/client/app/components/HubConfig/HubConfigPanelDetails.js
@@ -0,0 +1,85 @@
+import React from 'react';
+import {
+  defineMessages,
+  FormattedMessage,
+  } from 'react-intl';
+
+
+const messages = defineMessages({
+  title: {
+    id: "hubs.core.config.details.title",
+    defaultMessage: "Details",
+  },
+  intro: {
+    id: "hubs.core.config.details.intro",
+    defaultMessage: "Change additional hub configuration here.",
+  },
+  pagure_username: {
+    id: "hubs.core.config.details.pagure_username",
+    defaultMessage: "Pagure Username",
+  },
+  pagure_username_help: {
+    id: "hubs.core.config.details.pagure_username_help",
+    defaultMessage: "Your pagure username",
+  },
+  github_username: {
+    id: "hubs.core.config.details.github_username",
+    defaultMessage: "Github Username",
+  },
+  github_username_help: {
+    id: "hubs.core.config.details.github_username_help",
+    defaultMessage: "Your github username",
+  },
+  bugzilla_email: {
+    id: "hubs.core.config.details.bugzilla_email",
+    defaultMessage: "Bugzilla E-mail",
+  },
+  bugzilla_email_help: {
+    id: "hubs.core.config.details.bugzilla_email_help",
+    defaultMessage: "Your bugzilla e-mail address",
+  },
+});
+
+
+export default class DetailsPanel extends React.Component {
+
+  constructor(props) {
+    super(props);
+    this.handleChange = this.handleChange.bind(this);
+  }
+
+  handleChange(e) {
+    const name = e.target.name, value = e.target.value;
+    this.props.handleChange(name, value);
+  }
+
+  render() {
+    return (
+      <form onSubmit={(e) => {e.preventDefault();}}>
+        <FormattedMessage {...messages.title} tagName="h3" />
+        <FormattedMessage {...messages.intro} tagName="p" />
+        {["pagure_username", "github_username", "bugzilla_email"].map(function(x, i) {
+          return (
+            <div key={i} className="form-group row">
+              <label htmlFor={"hub-settings-details-" + x}>
+                <FormattedMessage {...messages[x]} />
+              </label>
+              <input
+                type="text"
+                name={x}
+                className={"form-control"}
+                id={"hub-settings-details-" + x}
+                onChange={this.handleChange}
+                value={this.props.hubConfig[x] || ""}
+                />
+              <p className="form-text text-muted">
+                <FormattedMessage {...messages[x + "_help"]} />
+              </p>
+            </div>
+          )
+        }, this)}
+      </form>
+
+    );
+  }
+}
diff --git a/hubs/utils/validators.py b/hubs/utils/validators.py
index 4d5ec86..8da8e1c 100644
--- a/hubs/utils/validators.py
+++ b/hubs/utils/validators.py
@@ -107,6 +107,14 @@ def FMNContext(value):
     raise ValueError('Invalid FMN context')
 
 
+def PagureUser(value):
+    """Fails if the Pagure username does not exist."""
+    response = requests.get("https://pagure.io/user/%s" % value, timeout=5)
+    if response.ok:
+        return value
+    raise ValueError('Invalid Pagure username: {}'.format(value))
+
+
 def PagureRepo(value):
     """Fails if the Pagure repository name does not exist."""
     try:
diff --git a/hubs/widgets/issues/__init__.py b/hubs/widgets/issues/__init__.py
index 616df54..c4bfd8f 100644
--- a/hubs/widgets/issues/__init__.py
+++ b/hubs/widgets/issues/__init__.py
@@ -13,29 +13,7 @@ class Issues(Widget):
     name = "issues"
     label = "Issues"
     position = "left"
-    parameters = [
-        dict(
-            name="github_username",
-            label="Github Username",
-            default="None",
-            validator=validators.Text,
-            help="Github username to show issues of",
-        ),
-        dict(
-            name="pagure_username",
-            label="Pagure Username",
-            default="None",
-            validator=validators.Text,
-            help="Pagure username to show issues of",
-        ),
-        dict(
-            name="bugzilla_username",
-            label="Bugzilla Username",
-            default="None",
-            validator=validators.Text,
-            help="Bugzilla username to show issues of",
-        )
-    ]
+    parameters = []
 
 
 class BaseView(RootWidgetView):
@@ -54,9 +32,9 @@ class BaseView(RootWidgetView):
 class GetBugzillaBugs(CachedFunction):
 
     def execute(self):
-        username = self.instance.config["bugzilla_username"]
+        email = self.instance.hub.config["bugzilla_email"]
         endpoint = "https://bugzilla.redhat.com/jsonrpc.cgi?method=Bug.search&params=[{{\"creator\":\"{}\"}}]"
-        response = requests.get(endpoint.format(username)).json()
+        response = requests.get(endpoint.format(email)).json()
         issues = response['result']['bugs']
         issues = issues[:min(5, len(issues))]
         return issues
@@ -64,6 +42,10 @@ class GetBugzillaBugs(CachedFunction):
     def should_invalidate(self, message):
         return False
 
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
+
+    # For testing purposes
     def _should_cache(self, value):
         return False
 
@@ -71,7 +53,7 @@ class GetBugzillaBugs(CachedFunction):
 class GetPagureIssues(CachedFunction):
 
     def execute(self):
-        username = self.instance.config["pagure_username"]
+        username = self.instance.hub.config["pagure_username"]
         endpoint = "https://pagure.io/api/0/user/{}/issues"
         response = requests.get(endpoint.format(username)).json()
         issues = response['issues_created']
@@ -81,6 +63,10 @@ class GetPagureIssues(CachedFunction):
     def should_invalidate(self, message):
         return False
 
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
+
+    # For testing purposes
     def _should_cache(self, value):
         return False
 
@@ -88,7 +74,7 @@ class GetPagureIssues(CachedFunction):
 class GetGithubIssues(CachedFunction):
 
     def execute(self):
-        username = self.instance.config["github_username"]
+        username = self.instance.hub.config["github_username"]
         endpoint = "https://api.github.com/search/issues?q=is:issue+author:{}&sort:updated"
         response = requests.get(endpoint.format(username)).json()
         issues = response['items']
@@ -98,5 +84,9 @@ class GetGithubIssues(CachedFunction):
     def should_invalidate(self, message):
         return False
 
+    def should_invalidate_on_hub_config_change(self, old_config):
+        return True
+
+    # For testing purposes
     def _should_cache(self, value):
         return False

